leetcode 494. Target Sum目标和+背包问题+动态规划DP

You are given a list of non-negative integers, a1, a2, …, an, and a target, S. Now you have 2 symbols + and -. For each integer, you should choose one from + and - as its new symbol.

Find out how many ways to assign symbols to make sum of integers equal to target S.

Example 1:
Input: nums is [1, 1, 1, 1, 1], S is 3.
Output: 5
Explanation:

-1+1+1+1+1 = 3
+1-1+1+1+1 = 3
+1+1-1+1+1 = 3
+1+1+1-1+1 = 3
+1+1+1+1-1 = 3

There are 5 ways to assign symbols to make the sum of nums be target 3.
Note:
The length of the given array is positive and will not exceed 20.
The sum of elements in the given array will not exceed 1000.
Your output answer is guaranteed to be fitted in a 32-bit integer.

这道题最直接的方法就是DFS深度优先遍历,不过可能超时,但是还有一个很棒的DP做法,我是参考网上的分析,主要分析如下:

1、该问题求解数组中数字只和等于目标值的方案个数,每个数字的符号可以为正或负(减整数等于加负数)。

2、该问题和矩阵链乘很相似,是典型的动态规划问题

3、举例说明: nums = {1,2,3,4,5}, target=3, 一种可行的方案是+1-2+3-4+5 =3

该方案中数组元素可以分为两组,一组是数字符号为正(P={1,3,5}),另一组数字符号为负(N={2,4})

因此: sum(1,3,5) - sum(2,4) = target

sum(1,3,5) - sum(2,4) + sum(1,3,5) + sum(2,4) = target + sum(1,3,5) + sum(2,4)

2sum(1,3,5) = target + sum(1,3,5) + sum(2,4)

2sum(P) = target + sum(nums)

sum(P) = (target + sum(nums)) / 2

由于target和sum(nums)是固定值,因此原始问题转化为求解nums中子集的和等于sum(P)的方案个数问题

4、求解nums中子集合只和为sum(P)的方案个数(nums中所有元素都是非负)

该问题可以通过动态规划算法求解

举例说明:给定集合nums={1,2,3,4,5}, 求解子集,使子集中元素之和等于9 = new_target = sum(P) = (target+sum(nums))/2

定义dp[10]数组, dp[10] = {1,0,0,0,0,0,0,0,0,0}

dp[i]表示子集合元素之和等于当前目标值的方案个数, 当前目标值等于9减去当前元素值

当前元素等于1时,dp[9] = dp[9] + dp[9-1]

dp[8] = dp[8] + dp[8-1]

dp[1] = dp[1] + dp[1-1]

当前元素等于2时,dp[9] = dp[9] + dp[9-2]

dp[8] = dp[8] + dp[8-2]

dp[2] = dp[2] + dp[2-2]

当前元素等于3时,dp[9] = dp[9] + dp[9-3]

dp[8] = dp[8] + dp[8-3]

dp[3] = dp[3] + dp[3-3]

当前元素等于4时,

当前元素等于5时,

dp[5] = dp[5] + dp[5-5]

最后返回dp[9]即是所求的解

还建议和leetcode 518. Coin Change 2 动态规划DPleetcode 279. Perfect Squares 类似背包问题 + 很简单的动态规划DP解决leetcode 377. Combination Sum IV 组合之和 + DP动态规划 + DFS深度优先遍历leetcode 416. Partition Equal Subset Sum 动态规划DP + 深度优先遍历DFS一起学习

还有leetcode 474. Ones and Zeroes若干0和1组成字符串最大数量+动态规划DP+背包问题

还有这道题leetcode 473. Matchsticks to Square 火柴摆正方形 + 一个经典深度优先遍历DFS的应用

代码如下:

#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <queue>
#include <stack>
#include <string>
#include <climits>
#include <algorithm>
#include <sstream>
#include <functional>
#include <bitset>
#include <numeric>
#include <cmath>
#include <regex>
#include <iomanip>

using namespace std;


class Solution
{
public:
    int findTargetSumWays(vector<int>& nums, int target)
    {
        int sum = accumulate(nums.begin(),nums.end(),0);    
        if (sum < target || (sum + target) % 2 == 1)
            return 0;

        int count = subSetSum(nums, (sum + target) / 2);
        return count;
    }

    int subSetSum(vector<int> a, int sum)
    {
        vector<int> dp(sum + 1, 0);
        dp[0] = 1;
        for (int i = 0; i < a.size(); i++)
        {
            for (int j = sum; j >= a[i]; j--)
            {
                dp[j] += dp[j - a[i]];
            }
        }
        return dp[sum];
    }


    int findTargetSumWaysByDFS(vector<int>& nums, int S)
    {
        if (nums.size() <= 0)
            return 0;

        int count = 0;
        getAll(nums, 0, 0, S, count);
        return count;
    }

    void getAll(vector<int> a, int index, int sum, int target, int& count)
    {
        if (index == a.size())
        {
            if (sum == target)
                count++;
            return;
        }
        else
        {
            getAll(a, index + 1, sum + a[index], target, count);
            getAll(a, index + 1, sum - a[index], target, count);
        }
    }
};
  • 1
    点赞
  • 2
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值